package com.example.depanntout.bdd

import android.util.Log
import android.widget.Toast
import com.example.depanntout.Client

class ClientDAO(private val dao: DAO) {
    fun createClient(client: Client) {
        dao.db.execSQL(
            "INSERT INTO clients (firstname, lastname, mail, tel, adresse) VALUES (?, ?, ?, ?, ?)",
            arrayOf(client.fistname, client.lastname, client.email, client.tel.toString(), client.adresse)
        )
    }

    fun deleteClient(client: Client) {
        dao.db.execSQL(
            "DELETE FROM clients where idClient = ?",
            arrayOf(client.idClient)
        )
    }

    fun getClients(): List<Client> {
        val clients: MutableList<Client> = arrayListOf<Client>()
        val cursor = dao.db.rawQuery("SELECT * FROM 'clients'", null)
        if (cursor.moveToFirst()) {
            do {
                Log.d("DatabaseRow", "Column1: ${cursor.getString(0)}, Column2: ${cursor.getString(1)}")
                val id = cursor.getInt(cursor.getColumnIndexOrThrow("idClient"))
                val firstname = cursor.getString(cursor.getColumnIndexOrThrow("firstname"))
                val lastname = cursor.getString(cursor.getColumnIndexOrThrow("lastname"))
                val tel = cursor.getString(cursor.getColumnIndexOrThrow("tel"))
                val email = cursor.getString(cursor.getColumnIndexOrThrow("mail"))
                val adresse = cursor.getString(cursor.getColumnIndexOrThrow("adresse"))

                val client = Client(id, firstname, lastname, email, tel, adresse)
                clients.add(client)
            } while (cursor.moveToNext())
        }
        cursor.close()
        return clients
    }
}