package com.example.depanntout

import android.content.Context
import android.content.Intent
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Button
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.example.depanntout.bdd.ClientDAO
import com.example.depanntout.bdd.CreateBdDepannTout
import com.example.depanntout.bdd.DAO

class clientAdapter(private val clients: List<Client>, private val context: Context) : RecyclerView.Adapter<clientAdapter.ClientViewHolder>() {
    class ClientViewHolder(itemView: View) : RecyclerView.ViewHolder(itemView) {
        val nomTextView: TextView = itemView.findViewById(R.id.nomTextView)
        val emailTextView: TextView = itemView.findViewById(R.id.emailTextView)
        val btnDetails: Button = itemView.findViewById(R.id.btnDetails)
        val btnDelete: Button = itemView.findViewById(R.id.btnDel)
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ClientViewHolder {
        val view = LayoutInflater.from(parent.context).inflate(R.layout.item_client, parent, false)
        return ClientViewHolder(view)
    }

    override fun onBindViewHolder(holder: ClientViewHolder, position: Int) {
        val client = clients[position]
        holder.nomTextView.text = client.fistname + " " + client.lastname
        holder.emailTextView.text = client.email

        holder.btnDetails.setOnClickListener {
            val intent = Intent(context, ClientDetails::class.java).apply {
                putExtra("ID", client.idClient)
                putExtra("FIRSTNAME", client.fistname)
                putExtra("LASTNAME", client.lastname)
                putExtra("MAIL", client.email)
                putExtra("TEL", client.tel)
                putExtra("ADRESSE", client.adresse)
            }
            context.startActivity(intent)
        }

        holder.btnDelete.setOnClickListener {
            val createBdDepannTout: CreateBdDepannTout = CreateBdDepannTout(context)
            val dao: DAO = DAO(context, createBdDepannTout)
            val clientDAO : ClientDAO = ClientDAO(dao)
            clientDAO.deleteClient(client)
        }
    }

    override fun getItemCount(): Int = clients.size
}