package com.example.depanntout

import android.content.Intent
import android.os.Bundle
import android.widget.Button
import android.widget.EditText
import android.widget.Toast
import androidx.activity.enableEdgeToEdge
import androidx.appcompat.app.AppCompatActivity
import androidx.core.view.ViewCompat
import androidx.core.view.WindowInsetsCompat
import com.android.volley.toolbox.JsonObjectRequest
import com.android.volley.toolbox.Volley
import com.example.depanntout.bdd.ClientDAO
import com.example.depanntout.bdd.CreateBdDepannTout
import com.example.depanntout.bdd.DAO
import org.json.JSONObject

class createClient : AppCompatActivity() {
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        enableEdgeToEdge()
        setContentView(R.layout.activity_create_client)
        ViewCompat.setOnApplyWindowInsetsListener(findViewById(R.id.main)) { v, insets ->
            val systemBars = insets.getInsets(WindowInsetsCompat.Type.systemBars())
            v.setPadding(systemBars.left, systemBars.top, systemBars.right, systemBars.bottom)
            insets
        }

        val buttonExit = findViewById<Button>(R.id.btnCancel)
        buttonExit.setOnClickListener() {
            finish()
        }

        val buttonCreate = findViewById<Button>(R.id.btnCreate)
        buttonCreate.setOnClickListener() {
            val firstname = findViewById<EditText>(R.id.inputObserv).text.toString()
            val lastname = findViewById<EditText>(R.id.inputClient).text.toString()
            val mail = findViewById<EditText>(R.id.inpMail).text.toString()
            val telephone = findViewById<EditText>(R.id.inpTel).text.toString()
            val adresse = findViewById<EditText>(R.id.inpAdresse).text.toString()
            val newClient: Client = Client(1, firstname, lastname, mail, telephone, adresse)
            val createBdDepannTout: CreateBdDepannTout = CreateBdDepannTout(this)
            val dao: DAO = DAO(this, createBdDepannTout)
            val clientDAO : ClientDAO = ClientDAO(dao)
            clientDAO.createClient(newClient)
            val intent = Intent(this, ListeClients::class.java)
            startActivity(intent)
            Toast.makeText(this, "Client ajouter", Toast.LENGTH_SHORT).show()
            finish()

            val queue = Volley.newRequestQueue(this)
            val url = "http://192.168.48.185:8000/client"
            val jsonObjectRequest = object : JsonObjectRequest(
                Method.POST, url, null,
                {  },
                {  }) {

                override fun getHeaders(): Map<String, String> {
                    val headers = HashMap<String, String>()
                    headers["Content-Type"] = "application/json"
                    return headers
                }

                override fun getBody(): ByteArray {
                    val jsonObject = JSONObject()
                    jsonObject.put("prenom", newClient.fistname)
                    jsonObject.put("nom", newClient.lastname)
                    jsonObject.put("email", newClient.email)
                    jsonObject.put("telephone", newClient.tel)
                    jsonObject.put("adresse", newClient.adresse)
                    return jsonObject.toString().toByteArray()
                }
            }

            queue.add(jsonObjectRequest)
        }
    }
}